/*	
 *	clipfpk.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Wed Nov 30 22:35:00 JST 2005 Naoyuki Sawa
 *	- ファイルパック形式、オンメモリファイルパック形式は、利用頻度が低いので、
 *	  コードサイズ節約のために、実装をclipmisc.cからclipfpk.cへ分離しました。
 */
#include "clip.h"

/*****************************************************************************
 *	ユーティリティ：ファイルパック形式
 *****************************************************************************/

static int
fpk_find(FILE* fp, const char* name, FILE_INFO* fi)
{
	int retval, i;
	FILE_PAC_INFO pi;

	/* fpk情報を読みます。 */
	/* 呼び出し時にファイル位置が先頭であること。この関数はrewind()しません。 */
	retval = fread(&pi, 1, sizeof pi, fp);
	if(retval != sizeof pi) DIE();
	if(pi.head != FILE_PAC_INFO_HEAD) DIE(); /* シグネチャ検査 */

	/* ファイル情報を走査して… */
	for(i = 0; i < pi.famount; i++) {
		/* ファイル情報を読みます。 */
		retval = fread(fi, 1, sizeof *fi, fp);
		if(retval != sizeof *fi) DIE();

		/* 見つけた？ */
		if(strncasecmp(fi->fname, name, sizeof fi->fname) == 0) break;
	}

	return i < pi.famount; /* 1:見つけた/0:見つからなかった */
}

int
fpk_size(const char* fname, const char* name)
{
	int retval;
	FILE* fp;
	FILE_INFO fi;

	/* fpkファイルを開きます。 */
	fp = fopen(fname, "rb");
	if(fp == NULL) DIE();

	/* ファイル情報を探します。 */
	retval = fpk_find(fp, name, &fi);
	if(!retval) DIE();

	/* fpkファイルを閉じます。 */
	fclose(fp);

	return fi.size;
}

int
fpk_load(const char* fname, const char* name, void* buffer, int buflen)
{
	int retval;
	FILE* fp;
	FILE_INFO fi;

	/* fpkファイルを開きます。 */
	fp = fopen(fname, "rb");
	if(fp == NULL) DIE();

	/* ファイル情報を探します。 */
	retval = fpk_find(fp, name, &fi);
	if(!retval) DIE();
	if((int)fi.size > buflen) DIE(); /* バッファ不足 */

	/* ファイルを読み込みます。 */
	retval = fseek(fp, fi.offset, SEEK_SET);
	if(retval != 0) DIE();
	retval = fread(buffer, 1, fi.size, fp);
	if(retval != (int)fi.size) DIE();

	/* fpkファイルを閉じます。 */
	fclose(fp);

	return fi.size; /* 読み込んだサイズを返します */
}

/*****************************************************************************
 *	ユーティリティ：オンメモリファイルパック形式
 *****************************************************************************/

const void*
fpk_address(const void* fpk, const char* name, int* size)
{
	int i;
	unsigned char* base;
	FILE_PAC_INFO* pi;
	FILE_INFO* fi;

	base = (unsigned char*)fpk;

	/* シグネチャを検査します。 */
	pi = (FILE_PAC_INFO*)(base + 0);
	if(pi->head != FILE_PAC_INFO_HEAD) DIE();

	/* ファイルエントリを探します。 */
	fi = (FILE_INFO*)(base + sizeof(FILE_PAC_INFO));
	for(i = 0; i < pi->famount; i++) {
		if(strncasecmp(fi->fname, name, sizeof fi->fname) == 0) break;
		fi++;
	}
	if(i == pi->famount) DIE();

	/* ファイルサイズを格納します。 */
	if(size) *size = fi->size;

	/* ファイルの先頭アドレスを返します。 */
	return base + fi->offset;
}

